-- #hide
--------------------------------------------------------------------------------
-- |
-- Module      :  Sound.ALUT.Config
-- Copyright   :  (c) Sven Panne 2006
-- License     :  BSD-style (see the file libraries/ALUT/LICENSE)
-- 
-- Maintainer  :  sven.panne@aedion.de
-- Stability   :  provisional
-- Portability :  portable
--
-- This purely internal module defines the platform-specific stuff which has
-- been figured out by configure.
--
--------------------------------------------------------------------------------

module Sound.ALUT.Config (
   alut_Init,
   alut_InitWithoutContext,
   alut_Exit,

   alut_GetError,
   alut_GetErrorString,

   alut_CreateBufferFromFile,
   alut_CreateBufferFromFileImage,
   alut_CreateBufferHelloWorld,
   alut_CreateBufferWaveform,

   alut_LoadMemoryFromFile,
   alut_LoadMemoryFromFileImage,
   alut_LoadMemoryHelloWorld,
   alut_LoadMemoryWaveform,

   alut_GetMIMETypes,

   alut_GetMajorVersion,
   alut_GetMinorVersion,

   alut_Sleep
) where

--------------------------------------------------------------------------------

                                                                              
                                                                             

                                             


                                             


                                                     


                                                             


                                                           


                                          


                                          


                                      


                                      


                                         


                                          


                                      


                                        


                                            


                                                                      
                                          

                                                                           
                                               

                                                                        
                                            

                                                                      
                                          

                                                          
                              

                                                                
                                    

                                                                 
                                     

                                                              
                                  

                                                                 
                                     

                                                                    
                                        

                                                                    
                                        

                                                                         
                                             

                                                                      
                                          

                                                                    
                                        

                                                       
                           

                                                          


                                                           


                                                         


                                                              
                               

                                                         


                                                         


                                                          


                                                         


                                                           


                                                            


                                                         


                                                                              


                                              


                                                          


                                                          


                                            


                                                      




--------------------------------------------------------------------------------

import Foreign.C
import Foreign.Ptr
import Sound.OpenAL.AL.BasicTypes


import Sound.OpenAL.AL.ALboolean



import Sound.OpenAL.AL.BufferInternal







--------------------------------------------------------------------------------



alut_Init :: Ptr CInt -> Ptr CString -> IO ALboolean
alut_Init argc argv = alutInit argc argv >> return (marshalALboolean True)

foreign import ccall unsafe "alutInit"
   alutInit :: Ptr CInt -> Ptr CString -> IO ()








--------------------------------------------------------------------------------








alut_InitWithoutContext :: Ptr CInt -> Ptr CString -> IO ALboolean
alut_InitWithoutContext _ _ = return (marshalALboolean True)



--------------------------------------------------------------------------------



alut_Exit :: IO ALboolean
alut_Exit = alutExit >> return (marshalALboolean True)

foreign import ccall unsafe "alutExit"
   alutExit :: IO ()








--------------------------------------------------------------------------------








alut_GetError :: IO ALenum
alut_GetError = return 0



--------------------------------------------------------------------------------

alut_GetErrorString :: ALenum -> IO String










alut_GetErrorString _ = return "<unknown ALUT error>"



--------------------------------------------------------------------------------








alut_CreateBufferFromFile :: CString -> IO ALuint
alut_CreateBufferFromFile _ = return (marshalBuffer Nothing)



--------------------------------------------------------------------------------








alut_CreateBufferFromFileImage :: Ptr a -> ALsizei -> IO ALuint
alut_CreateBufferFromFileImage _ _ =  return (marshalBuffer Nothing)



--------------------------------------------------------------------------------








alut_CreateBufferHelloWorld :: IO ALuint
alut_CreateBufferHelloWorld =  return (marshalBuffer Nothing)



--------------------------------------------------------------------------------








alut_CreateBufferWaveform :: ALenum -> ALfloat -> ALfloat -> ALfloat -> IO ALuint
alut_CreateBufferWaveform _ _ _ _ =  return (marshalBuffer Nothing)



--------------------------------------------------------------------------------








alut_LoadMemoryFromFile :: CString -> Ptr ALenum -> Ptr ALsizei -> Ptr ALfloat -> IO (Ptr b)
alut_LoadMemoryFromFile _ _ _ _ = return nullPtr



--------------------------------------------------------------------------------








alut_LoadMemoryFromFileImage :: Ptr a -> ALsizei -> Ptr ALenum -> Ptr ALsizei -> Ptr ALfloat -> IO (Ptr b)
alut_LoadMemoryFromFileImage _ _ _ _ _ = return nullPtr



--------------------------------------------------------------------------------








alut_LoadMemoryHelloWorld :: Ptr ALenum -> Ptr ALsizei -> Ptr ALfloat -> IO (Ptr b)
alut_LoadMemoryHelloWorld _ _ _ = return nullPtr



--------------------------------------------------------------------------------








alut_LoadMemoryWaveform :: ALenum -> ALfloat -> ALfloat -> ALfloat -> Ptr ALenum -> Ptr ALsizei -> Ptr ALfloat -> IO (Ptr b)
alut_LoadMemoryWaveform _ _ _ _ _ _ _ = return nullPtr



--------------------------------------------------------------------------------








alut_GetMIMETypes :: ALenum -> IO CString
alut_GetMIMETypes _ = return nullPtr



--------------------------------------------------------------------------------








alut_GetMajorVersion :: IO ALint
alut_GetMajorVersion = return 0



--------------------------------------------------------------------------------








alut_GetMinorVersion :: IO ALint
alut_GetMinorVersion = return 0



--------------------------------------------------------------------------------








alut_Sleep :: ALfloat -> IO ALboolean
alut_Sleep d = mySleep d  >> return (marshalALboolean True)

mySleep :: ALfloat -> IO ()







mySleep = return ()




